/***********************************************/
/* keys v. 2.0                                 */
/* written by john nguyen                      */
/* date written  12/13/1988                    */
/***********************************************/
#include <stdio.h>
#include <dos.h>

#define ON 1,13
#define OFF 13,1

#define TRUE 1
#define NUM 5

#define NORMAL 7
#define BOLD   15
#define REVERSE 112
#define R_BLINK 140

#define U_ARRO 72
#define D_ARRO 80
#define ENTER 28

 struct  scancode { unsigned char acode;
                    unsigned char scode;} ;

struct scancode getkey();

void setcurs (unsigned char, unsigned char);

void cursw (int, int);

typedef struct  { int  keynum;
                  char keyname[8];
                  char keydef[60]; } newdef;


int  keynums[15] = {59,60,61,62,63,64,65,66,67,68,
                      104,105,106,107,108};

char *defptr = "DIR";

char *nameptr[15] = {"F1","F2","F3","F4","F5",
                       "F6","F7","F8","F9","F10",
                       "ALT-F1","ALT-F2","ALT-F3","ALT-F4","ALT-F5"};

newdef keydef2[15];

FILE *fptr;

main(argc,argv)

int argc;
char *argv[];

{

    static char *items[NUM] =
                      { " VIEW THE CURRENT FUNCTION KEY SETTING.",
                        " EDIT FUNCTION KEY.",
                        " CLEAR ALL FUNTION KEYS.",
                        " EXIT KEY WITHOUT UPDATE FUNCTION KEY.",
                        " QUIT.", };
extern FILE *fptr;
int curpos;
struct scancode incode;
int i,fborder,j;

cursw(OFF);

clearsc(1,1,25,80);
curpos=0;
fborder = 0;

   if (( fptr=fopen("c:\key.dat","rb")) == NULL)
      makefile();

   else
     {
      if( (fptr=fopen("c:\key.dat","rb")) == NULL )
          {
          clearsc(1,1,25,80);
          printv(" can not open file key.dat.",7,10,10);
          cursw(ON);
          exit();
          }

        fread(keydef2,sizeof(keydef2[0]),15,fptr);
        fclose(fptr);
     }



if (argc > 1 )

    switch (*argv[1])
       {
         case 'E' :
         case 'e' :
              edit();
              wfile();
              clearsc(1,1,25,80);
              cursw(ON); exit();

         case 'F' :
         case 'f' :
              clearall();
              clearsc(1,1,25,80);
              cursw(ON); exit();

         case 'V' :
         case 'v' :
              view();
              clearsc(1,1,25,80);
              cursw(ON); exit();

         case 'U' :
         case 'u' :
              updt();
              clearsc(1,1,25,80);
              line();
              printv("  QUICK UPDATE   ",BOLD,1,30);
              printv("FUNCTION KEYS UPDATED.",R_BLINK,8,30);
              printv("Press any key to exit...",NORMAL,10,30);
              getkey();
              clearsc(1,1,25,80);
              cursw(ON); exit();

         case 'B' :
         case 'b' :
              updt();
              cursw(ON); exit();

         default:
            clearsc(1,1,25,80);
            line();
            printv("**** WARNING ****",BOLD,1,30);
            putch('\a');
            printv("INVALID PARAMETER...",R_BLINK,8,25);
            printv("Try again and chose one of the option below:",
                   BOLD,10,20);
            printv("'V' to view key.",7,12,25);
            printv("'E' to edit key.",7,13,25);
            printv("'U' to update key.",7,14,25);
            printv("'F' to clear key.",7,15,25);

            printv("Press any key to exit...",NORMAL,18,25);
            getkey();
            clearsc(1,1,25,80);
            cursw(ON); exit();
  }

 clearsc(1,1,25,80);
 while (TRUE)

      {

  if (fborder == 0)
      {
       clearsc(1,1,25,80);
       line();
       border();
       printv("Use ",BOLD,24,10);
       printv("",REVERSE,24,14);
       printv(" and ",BOLD,24,15);
       printv("",REVERSE,24,20);
       printv(" keys to select option, ",BOLD,24,21);
       printv("ENTER",REVERSE,24,45);
       printv(" to process option.",BOLD,24,50);
       printv("KEYS VERSION 2.0 ",BOLD,1,30);
      }
        display (items,NUM,curpos);
        incode = getkey();
        switch (incode.scode)
           {
             case U_ARRO:  if (curpos>0)
                                --curpos;
                           else
                                curpos = 4;
                           fborder = 1;
                           break;

             case D_ARRO:  if (curpos<NUM-1)
                                ++curpos;
                           else
                                 curpos = 0;
                           fborder = 1;
                           break;
             case ENTER:  action(curpos);
                          fborder = 0;
                          break;
             }
        }
  }



/* display routine */

display(arr,size,pos)
char *arr[];
int size, pos;

{
  int j;

  for (j=0;j<size;j++)
      {
        if (j==pos)
           printv(*(arr+j),REVERSE,j+7,20);
        else
           printv(*(arr+j),NORMAL,j+7,20);
         }
  }


/* action routine */

action(pos)
int pos;

{
int i;

switch(pos)

  {

  case 0:
       view();return;

  case 1:
       edit();return;
  case 3:
       wfile();
       clearsc(1,1,25,80);
       line();
       printv("    EXIT MENU    ",BOLD,1,30);
       putch('\a');
       printv("KEY.DAT UPDATED.",R_BLINK,5,25);
       printv("Press any key to complete exit...",NORMAL,7,20);
       getkey();
       clearsc(1,1,25,80);
       cursw(ON); exit();
  case 2:
       clearall();
       return;

  case 4:
       wfile();
       updt();
       clearsc(1,1,25,80);
       cursw(ON); exit();
     }
}


/* write routine */

wfile()

  {
     extern FILE *fptr;

     fptr = fopen("c:\key.dat","wb");
          fwrite(keydef2,sizeof(keydef2[0]),15,fptr);
     fclose(fptr);
   }


/* update routine */

updt()

  {
  int i;

  for (i=0;i<15;i++)
  printf ("\x1b[0;%d;\"%s\";13p", keydef2[i].keynum,keydef2[i].keydef);
  }

/* view routine */

view()

{
   int i;

  clearsc(1,1,25,80);

 line();
 printv("    VIEW MENU    ",BOLD,1,30);

  printv("KEYNAME",BOLD,4,15);
  printv("CURENT SETTING",BOLD,4,40);

  for (i=0;i<15;++i)
     {
     printv(keydef2[i].keyname,NORMAL,i+6,15);
     printv(keydef2[i].keydef,NORMAL,i+6,40);

      }
     printv("Hit any key to return to main menu...",BOLD,23,15);
     getkey();
 }

/* edit routine */

edit()

{
 int i,keywrk;
 char ch;

 cursw(ON);

 top:

   clearsc(1,1,25,80);
   line();
   printv("    EDIT MENU    ",BOLD,1,30);

   printv("KEY NAME ",BOLD,4,20);
   printv("CURRENT SETTING ",BOLD,4,40);

  for (i=0;i<15;++i)
     {

       printv(keydef2[i].keyname,7,i+6,20);
       printv(keydef2[i].keydef,7,i+6,40);

      }

     fflush(stdin);
     printv(" Hit the function key to redefine :",NORMAL,21,5);
     setcurs(21,42);
     keywrk = ask();
     fflush(stdin);

    printv("",BOLD,23,1);
    printv("",BOLD,23,60);

    readstr(keydef2[keywrk-1].keydef,23,2,60);

   printv(" Do you want to redefine another key (Y/N)? ",NORMAL,24,5);
     setcurs(24,49);

top2:
     ch = getch();
     if(ch == 'y' || ch == 'Y')   goto top;
     else
       if (ch == 'n' || ch == 'N') goto top3;
       else
          {
           putch('\a');
           putch(ch);
           setcurs(24,49);
           goto top2;
           }

top3:
     cursw(OFF);

     }

/* ask routine */

ask(keyno)
int keyno;
{
    struct scancode askcode;

    doagain:

    askcode = getkey();
    switch(askcode.scode)
      {
        case 59:
             printv("F1",7,21,42);
             printv("F1 :",7,22,23);
             keyno = 1;
             setcurs(22,28);
             break;
        case 60:
             printv("F2",7,21,42);
             printv("F2 :",7,22,23);
             keyno = 2;
             setcurs(22,28);
             break;
        case 61:
             printv("F3",7,21,42);
             printv("F3 :",7,22,23);
             keyno = 3;
             setcurs(22,28);
             break;
        case 62:
             printv("F4",7,21,42);
             printv("F4 :",7,22,23);
             keyno = 4;
             setcurs(22,28);
             break;
        case 63:
             printv("F5",7,21,42);
             printv("F5 :",7,22,23);
             keyno = 5;
             setcurs(22,28);
             break;
        case 64:
             printv("F6",7,21,42);
             printv("F6 :",7,22,23);
             keyno = 6;
             setcurs(22,28);
             break;
        case 65:
             printv("F7",7,21,42);
             printv("F7 :",7,22,23);
             keyno = 7;
             setcurs(22,28);
             break;
        case 66:
             printv("F8",7,21,42);
             printv("F8 :",7,22,23);
             keyno = 8;
             setcurs(22,28);
             break;
        case 67:
             printv("F9",7,21,42);
             printv("F9 :",7,22,23);
             keyno = 9;
             setcurs(22,28);
             break;
        case 68:
             printv("F10",7,21,42);
             printv("F10 :",7,22,23);
             keyno = 10;
             setcurs(22,28);
             break;
        case 104:
             printv("ALT-F1",7,21,42);
             printv("ALT-F1 :",7,22,23);
             keyno = 11;
             setcurs(22,32);
             break;
        case 105:
             printv("ALT-F2",7,21,42);
             printv("ALT-F2 :",7,22,23);
             keyno = 12;
             setcurs(22,32);
             break;
        case 106:
             printv("ALT-F3",7,21,42);
             printv("ALT-F3 :",7,22,23);
             keyno = 13;
             setcurs(22,32);
             break;
        case 107:
             printv("ALT-F4",7,21,42);
             printv("ALT-F4 :",7,22,23);
             keyno = 14;
             setcurs(22,32);
             break;
        case 108:
             printv("ALT-F5",7,21,42);
             printv("ALT-F5 :",7,22,23);
             keyno = 15;
             setcurs(22,32);
             break;
        default:
             goto doagain;
       }

     printv(" Enter string for ",7,22,5);
     return (keyno);

 }

/* line routine */

line()

   {
      int k;

      for ( k=1; k<=78; k++)
        {printv("",BOLD,0,k);
         printv("",BOLD,2,k); }

         printv("",BOLD,0,0);
         printv("",BOLD,2,0);

         printv("",BOLD,0,79);
         printv("",BOLD,2,79);

         printv("",BOLD,1,0);
         printv("",BOLD,1,79);

   }


/* getkey routine */

struct scancode getkey()
    {
struct scancode incode1;

      union REGS reg;
      reg.h.ah = 0;
      int86 (0x16,&reg,&reg);

      incode1.acode = reg.h.al;
      incode1.scode = reg.h.ah;

      return(incode1);
     }


/* set curs routine */

void setcurs(row,col)

unsigned char row, col;

{
  union REGS reg;
  reg.h.ah = 2;
  reg.h.dh = row;
  reg.h.dl = col;
  reg.h.bh = 0;
  int86(0x10,&reg,&reg);

}


/* makefile routine */

makefile()
 {
  int i;

  for (i=0;i<15;i++)
      {
        keydef2[i].keynum = keynums[i];
        strcpy (keydef2[i].keydef,defptr);
        strcpy (keydef2[i].keyname,nameptr[i]);
       }

  if( (fptr=fopen("key.dat","wb")) == NULL )
     {
      clearsc(1,1,25,80);
      printv(" can not create default key.dat.",7,10,10);
      cursw(ON); exit();
      }

  fwrite(keydef2,sizeof(keydef2[0]),15,fptr);
  fclose(fptr);

  }

/* clear screen routine */
int clearsc(trow,tcol,brow,bcol)

   int trow, tcol,  brow, bcol;
   {
    union REGS inreg, outreg;
    if (trow < 1 ) trow = 1;
    if (trow > 25 ) trow = 25;
    if (tcol < 1 ) tcol = 1;
    if (tcol > 80 ) tcol = 80;

    if (brow < 1 ) brow = 1;
    if (brow > 25 ) brow = 25;
    if (bcol < 1 ) bcol = 1;
    if (bcol > 80 ) bcol = 80;

inreg.h.ah = 0x06;
inreg.h.al = 0;
inreg.h.ch = trow - 1;
inreg.h.cl = tcol - 1;
inreg.h.dh = brow - 1;
inreg.h.dl = bcol - 1;
inreg.h.bh = 0x07;

int86(0x10, &inreg, &outreg);

}

/* border routine */

border()

  {
  int i;

  for (i=1;i<61;i++)
        {printv("",BOLD,4,i+10);
         printv("",BOLD,14,i+10); }

         printv("",BOLD,4,11);
         printv("",BOLD,14,11);

         printv("",BOLD,4,71);
         printv("",BOLD,14,71);

   for (i=1;i<10;i++)
      {  printv("",BOLD,4+i,11);
         printv("",BOLD,4+i,71); }
  }

/* set cursor on or off */

void cursw(start,end)

int start,end;

{
 union REGS regs;
 regs.h.ch = start;
 regs.h.cl = end;
 regs.h.ah = 1;
 int86(0x10,&regs,&regs);
 }

/* fresh routine */
freshkey(str,lenn)
char *str;
int lenn;

{
int j;

  for (j=0;j<lenn;++j)
      *(str+j) = 0x00;
  }


/* clearall routine */

clearall()

{
int j;
       for (j=0;j<15;++j)
            freshkey(keydef2[j].keydef,60);

       updt();
       clearsc(1,1,25,80);
       line();
       printv("   CLEAR KEYS    ",BOLD,1,30);
       printv("FUNCTION KEYS CLEARED.",R_BLINK,8,30);
       printv("Press any key to return to main menu...",NORMAL,10,20);
       getkey();
    }

